import type { Discriminator, SupportedValueTypes } from "@octopusdeploy/step-inputs";

export type InitialInputs<StepInputs> = {
    [K in keyof StepInputs]: InitialInput<StepInputs[K]>;
};

export type InitialInput<T> = T extends Discriminator<infer D>
    ? D
    : T extends SupportedValueTypes
    ? T
    : T extends Array<infer T>
    ? Array<InitialInput<T>>
    : // eslint-disable-next-line @typescript-eslint/ban-types
    T extends object
    ? InitialInputs<T>
    : never;
