import type { InputPathToObject } from "@octopusdeploy/step-inputs";
import type { InitialInputs } from "./InitialInputs";
import type { CommonInputProps } from "./InputComponents";

export function radioButtons<Input>(props: RadioButtonProps<Input>): RadioButtonsComponent {
    return {
        type: "radio-buttons",
        ...props,
    };
}

export interface RadioButtonsComponent extends RadioButtonProps<unknown> {
    type: "radio-buttons";
}

export interface RadioButtonProps<InputObject> extends CommonInputProps {
    input: InputPathToObject<InputObject>;
    options: RadioButtonOption<InputObject>[];
}

export interface RadioButtonOption<InputObject> {
    label: string;
    newValue: InitialInputs<InputObject>;
}
