import type { SectionComponent } from "./Section";

export function sectionGroup<TInputComponent>(props: SectionGroupProps<TInputComponent>): SectionGroupComponent<TInputComponent> {
    return {
        type: "section group",
        ...props,
    };
}

export interface SectionGroupComponent<TInputComponents> extends SectionGroupProps<TInputComponents> {
    type: "section group";
}

export interface SectionGroupProps<TInputComponents> {
    title: string;
    content: SectionGroupContent<TInputComponents>[];
}

export type SectionGroupContent<TInputComponents> = SectionComponent<TInputComponents> | TInputComponents;
