import type { InitialInputs } from "./InitialInputs";
import type { EmptyInitialValue, ObjectInputPaths, PackageReference } from "@octopusdeploy/step-inputs";
import type { FormContent } from "./FormContent";
import type { StepInputComponent } from "./InputComponents";

export interface StepUI<StepInputs> {
    editInputsForm: EditStepInputsForm<StepInputs>;
    createInitialInputs: (initialInputFactories: StepInitialInputFactories) => InitialInputs<StepInputs>;
}

export interface StepInitialInputFactories extends EmptyInitialInputFactories {
    createEmptyPackageReference: () => PackageReference;
}

export interface EmptyInitialInputFactories {
    emptyInitialValue: EmptyInitialValue;
}

export type EditStepInputsForm<StepInputs> = (inputPaths: ObjectInputPaths<StepInputs>) => FormContent<StepInputComponent>[];
